#!/usr/bin/perl

#┌─────────────────────────────────
#│  PETIT BOARD v5.4 (2003/01/10)
#│  Copyright(C) Kent Web 2003
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  PETIT BOARD v9.0 LOCK : admin.cgi - 2023/06/09
#│  Edited by TRANSFORM Since 2012
#│  https://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);
use vars qw(%in %cf);
use lib "./lib";
use CGI::Session;
use Digest::SHA::PurePerl qw(sha256_base64);

# 設定ファイル認識
require "./init.cgi";
%cf = set_init();

# データ受理
%in = parse_form();

# 認証
require "./lib/login.pl";
auth_login();

if ($in{data_men}) { data_men(); }
if ($in{pass_mgr}) { pass_mgr(); }

# メニュー画面
menu_html();

#-----------------------------------------------------------
#  メニュー画面
#-----------------------------------------------------------
sub menu_html {
	header("メニューTOP");
	print <<EOM;
<div id="body">
<div id="main">
<div id="main-in">
<div class="menu-msg">選択ボタンを押してください。</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<table class="form-tbl">
<tr>
	<th>選択</th>
	<th width="280">処理メニュー</th>
</tr><tr>
	<td><input type="submit" name="data_men" value="選択"></td>
	<td>&nbsp; データ管理</td>
</tr><tr>
	<td><input type="submit" name="pass_mgr" value="選択"></td>
	<td>&nbsp; パスワード管理</td>
</tr><tr>
	<td><input type="submit" name="logoff" value="選択"></td>
	<td>&nbsp; ログアウト</td>
</tr><tr>
	<td class="ta-c"><input type="button" value="選択" onclick="javascript:window.location='$cf{bbs_cgi}'"></td>
	<td>&nbsp; 掲示板へ戻る</td>
</tr>
</table>
</form>
</div></div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  データ管理
#-----------------------------------------------------------
sub data_men {
	# 修正フォーム
	if ($in{job} eq "edit" && $in{no}) {
		
		my @log;
		open(DAT,"$cf{logfile}") or err_msg("open err: $cf{logfile}");
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			if ($in{no} == $no) {
				@log = ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2);
				last;
			}
		}
		close(DAT);
		
		if (@log == 0) { err_msg("該当記事は存在しません"); }
		
		# 修正フォーム
		edit_form(@log);
	
	# 修正実行
	} elsif ($in{job} eq "edit2") {
		
		# 入力値補正
		if ($in{url} eq 'http://') { $in{url} = ''; }
		$in{sub} ||= '無題';
		
		# アイコン
		my @icon;
		foreach (@{$cf{icon}}) {
			my ($ico,$nam) = split(/,/);
			push(@icon,$ico);
		}
		
		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			if ($no == $in{no}) {

 			#記事をグラデーション
    			if ($cf{grad}) {
    				$in{comment} = CreatGradation("$in{comment}");
    			}

				$_ = "$no<>$reno<>$date<>$in{name}<>$in{email}<>$in{sub}<>$in{comment}<>$in{url}<>$host<>$pw<>$in{color}<>$in{gradation}<>$lock<>$in{color2}<>\n";
			}
			push(@data,$_);
		}
		
		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を修正しました");

	# スレッドロック開閉
	} elsif ($in{job} eq "lock" && $in{no}) {

		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			# スレッドロック開閉
			if ($in{no} == $no) {
				if ($lock == 0) { $lock = 1; } else { $lock = 0; }
				$_ = "$no<>$reno<>$date<>$name<>$eml<>$sub<>$com<>$url<>$host<>$pw<>$col<>$grad<>$lock<>$color2<>\n";
			}
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事のロック開閉を調整しました");

	# 削除処理
	} elsif ($in{job} eq "dele" && $in{no}) {

		# データオープン
		my @data;
		open(DAT,"+< $cf{logfile}") or err_msg("open err: $cf{logfile}");
		eval "flock(DAT, 2);";
		my $top = <DAT>;
		while (<DAT>) {
			my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);

			# 親/子削除
			next if ($in{no} == $no or $in{no} == $reno);
			
			push(@data,$_);
		}

		# 更新
		unshift(@data,$top);
		seek(DAT, 0, 0);
		print DAT @data;
		truncate(DAT, tell(DAT));
		close(DAT);

		# 完了メッセージ
		message("記事を削除しました");

	}

	# 管理を表示
	header("管理画面");
	back_btn();
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="sub-ttl"> データ管理</div>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="sid" value="$in{sid}">
<p>処理を選択して送信ボタンを押してください。</p>
処理：
<select name="job">
<option value="edit">編集</option>
<option value="dele">削除</option>
<option value="lock">ロック</option>
</select>
<input type="submit" value="送信する" />
EOM

	open(IN,"$cf{logfile}") or err_msg("open err: $cf{logfile}");
	my $top = <IN>;
	while (<IN>) {
		my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = split(/<>/);
		$name = qq|<a href="mailto:$eml">$name</a>| if ($eml);

	my @col = split(/\s+/,$cf{colors});

		if (!$reno) {
			print qq|<div class="main">|;
		} else {
			print qq|<div class="sub">|;
		}

		print qq|<input type="radio" name="no" value="$no" />[$no]\n|;
		print qq|<b class="sub">$sub</b> 名前：<b>$name</b> 日時：$date [$host]\n|;

		if ($lock == 1) {
			print qq|<img src="cmn/lock02s.png" height="24px" class="clip" alt="" />&nbsp;&nbsp;|;
		}

		if (!$reno) {
			print qq|<div class="com"><span style="color:$col[$col]">$com</span></div>\n|;
		} else {
			print qq|<div class="com"><span style="color:$col">$com</span></div>\n|;
		}
		print qq|</div>\n|;
	}
	close(IN);

	print <<EOM;
</form>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  修正フォーム
#-----------------------------------------------------------
sub edit_form {
	my ($no,$reno,$date,$name,$eml,$sub,$com,$url,$host,$pw,$col,$grad,$lock,$color2) = @_;
	$com =~ s|<br( /)?>|\n|g;
    	$com =~ s/<br>/\r/g;
    	$com =~ s/<br \/>/\r/g;
    	$com =~ s/<(?:[^>']*|([']).*\1)*>//gs;
	$url ||= 'http://';

	# 色選択ボタン
	my @col = split(/\s+/,$cf{colors});
	my $color;
	foreach (0 .. $#col) {
		if ($_ eq $col) {
			$color .= qq|<input type="radio" name="color" value="$_" checked="checked" />|;
		} else {
			$color .= qq|<input type="radio" name="color" value="$_" />|;
		}
		$color .= qq|<span style="color:$col[$_]">■</span>\n|;
	}

	# 返信色選択ボタン
        my @resc1 = split(/\s+/, $cf{colors_res});
        my @resc2 = split(/\s+/, $cf{colors_res2});
	my $op_colors;
	foreach (0 .. $#resc1) {
		if ($col eq $resc1[$_]) {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]" selected>$resc2[$_]\n|;
		} else {
			$op_colors .= qq|<option value="$resc1[$_]" style="color:$resc1[$_]">$resc2[$_]\n|;
		}
	}

	# グラデーションプルダウン
        my @grd = split(/\s+/, $cf{GradStartColor});
        my @grdn = split(/\s+/, $cf{GradName});
	my $op2_grad;
        foreach (0 .. $#grdn) {
        if ($grad eq $_) {
			$op2_grad .= qq|<option value="$_" style="color:$grd[$_]" selected>$grdn[$_]\n|;
		} else {
			$op2_grad .= qq|<option value="$_" style="color:$grd[$_]">$grdn[$_]\n|;
		}
	}

	# タイトル背景プルダウン
        my @col3 = split(/\s+/, $cf{colors_b});
        my @col4 = split(/\s+/, $cf{colors_b2});
	my $color_b;
	foreach (0 .. $#col3) {
		if ($col3[$_] eq $color2) {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]" selected>$col4[$_]</option>\n|;
		} else {
			$color_b .= qq|<option value="$col3[$_]" style="color:$col3[$_]">$col4[$_]</option>\n|;
		}
	}

	my ($parent,$rest);
	if (!$reno) {
		$parent = "<span style=\"color:#8d93c8\">[親記事]</span>";
	} else {
		$rest = "<span style=\"color:#e29399\">[返信記事]</span>";
	}

	header("管理モード &gt; 修正フォーム");
	back_btn('data_men');
	print <<EOM;
<div id="main">
<div id="main-in">
<div class="sub-ttl"> 編集フォーム</div>
<p>▼変更する部分のみ修正して送信ボタンを押して下さい。</p>
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="data_men" value="1">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="job" value="edit2" />
<input type="hidden" name="no" value="$in{no}" />
<div id="reg-area">
<div id="reg-box">
<table id="reg-tbl">
<tr>
<div id="classify">$parent $rest</div>
	<th>名前</th>
	<td><input type="text" name="name" value="$name" class="reg-name" /></td>
</tr>
EOM
	if (!$reno) {
		print qq|<tr><th>E-mail</th><td><input type="text" name="email" value="$eml" class="reg-name" /></td>|;
		print qq|</tr><tr><th>件名</th><td><input type="text" name="sub" value="$sub" class="reg-name" /></td></tr>|;
	}
	print <<EOM;
<tr><tr>
	<th width="106">TITLE背景色</th>
	<td>
	<div class="select-wrap select-primary">
		<select name="color2" class="dropdown-select" />
			$color_b
		</select>
	</div>
		<div class="sample"><a href="$cf{bbs_cgi}?mode=ttlback" target="title" onclick="ttlbg('$cf{bbs_cgi}?mode=ttlback')">[タイトル背景色参照]</a></div>
	</td>
</tr>
	<th>コメント</th>
	<td><span style="font-size:9.5pt;">行頭に「♪」をつけるとその行がグラデーションします<br />
	<textarea name="comment" rows="6">$com</textarea></td>
</tr>
EOM
	if (!$reno) {
		print qq|<tr><th>URL</th><td><input type="text" name="url" value="$url" class="reg-url" /></td></tr>|;
	}
	print <<EOM;
<tr>
	<th>文字色</th>
	<td>
EOM
	if ($reno) {
		print qq|<select name="color">$op_colors</select>|;
	} else {
		print qq|$color|;
	}
	print <<EOM;
</td>
</tr><tr>
	<th><B>Grad</B></th>
	<td>
	<div class="select-wrap select-inverse">
		<select name="gradation" class="dropdown-select">$op2_grad</select>[<a href="$cf{bbs_cgi}?mode=grad" target="popwin" onclick="popup('$cf{bbs_cgi}?mode=grad')">サンプル</a>]
	</div>
	</td>
</tr>
</table>
<input type="submit" value="送信する" />
</form>
</div></div>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  文字列グラデーション化(文字列、開始色、中間色、終了色)
#-----------------------------------------------------------
sub GradStr2{

    my $Str = $_[0];
    my $ColorFrom = $_[1];
    my $ColorIn = $_[2];
    my $ColorTo = $_[3];

    my $Len = Klength($Str);

    my $FromLen = int($Len / 2);
    my $ToLen = $Len - $FromLen;

    my ($FromStr,$i,$ToStr);
    $FromStr = "";
    for($i = 1;$i <= $FromLen;$i++){
        $FromStr = $FromStr . KcharAt($Str, $i);
    }

    $ToStr = "";
    for($i = $FromLen + 1;$i <= $Len;$i++){
        $ToStr = $ToStr . KcharAt($Str, $i);
    }

    if($FromLen == $ToLen){
        $ToStr = KcharAt($FromStr, $FromLen) . $ToStr;
    }else{
        $FromStr = $FromStr . KcharAt($ToStr, 1);
    }

    my $FromTagStr = GradStr($FromStr, $ColorFrom, $ColorIn);
    my $ToTagStr = GradStr($ToStr, $ColorIn, $ColorTo);

    my @S = split(/<\/span>/, $ToTagStr);
    shift(@S);
    $ToTagStr = join("</span>", @S, "");

    return ($FromTagStr . $ToTagStr);
}

#-----------------------------------------------------------
#  文字列グラデーション化(文字列、開始色、終了色)
#-----------------------------------------------------------
sub GradStr{

    my $Str = $_[0];
    my $ColorFrom = $_[1];
    my $ColorTo = $_[2];
    
    my $StaTag = '<span style="color:#';
    my $EndTag = '</span>';

    my $Len = Klength($Str);

    if(substr($ColorFrom, 0, 1) eq "#"){
        $ColorFrom = substr($ColorFrom, 1, 6);
    }
    if(substr($ColorTo, 0, 1) eq "#"){
        $ColorTo = substr($ColorTo, 1, 6);
    }

    my (%Red, %Green, %Blue);
    $Red{'from'} = hex(substr($ColorFrom, 0, 2));
    $Green{'from'} = hex(substr($ColorFrom, 2, 2));
    $Blue{'from'} = hex(substr($ColorFrom, 4, 2));

    $Red{'to'} = hex(substr($ColorTo, 0, 2));
    $Green{'to'} = hex(substr($ColorTo, 2, 2));
    $Blue{'to'} = hex(substr($ColorTo, 4, 2));

    $Red{'level'} = GetLev($Red{'from'}, $Red{'to'}, $Len - 1);
    $Green{'level'} = GetLev($Green{'from'}, $Green{'to'}, $Len - 1);
    $Blue{'level'} = GetLev($Blue{'from'}, $Blue{'to'}, $Len - 1);

    $Red{'color'} = $Red{'from'} - $Red{'level'};
    $Green{'color'} = $Green{'from'} - $Green{'level'};
    $Blue{'color'} = $Blue{'from'} - $Blue{'level'};

    my ($TagStr,$i,$FColor);
    $TagStr = "";
    for ($i = 0 ;$i <= $Len - 1;$i++){
        $Red{'color'} = $Red{'color'} + $Red{'level'};
        $Green{'color'} = $Green{'color'} + $Green{'level'};
        $Blue{'color'} = $Blue{'color'} + $Blue{'level'};
        if ($i < $Len - 1 ){
            $FColor = sprintf("%02X", $Red{'color'}) 
                    . sprintf("%02X", $Green{'color'})
                    . sprintf("%02X", $Blue{'color'})
        } else {
            $FColor = $ColorTo;
        }
        $FColor = lc $FColor;

        $TagStr = $TagStr . $StaTag . $FColor . ';">' . KcharAt($Str, $i + 1) . $EndTag;
    }
    return ($TagStr);
}

#-----------------------------------------------------------
#  グラデーション階調を算出 引数(開始色,終了色,段階)
#-----------------------------------------------------------
sub GetLev{

    my $F = $_[0];
    my $T = $_[1];
    my $n = $_[2];
    my $sa = $T - $F;

    my $am;
    if ($n == 0) {$am = 0;}
    else {$am = $sa % $n; $am = ($sa - $am) / $n;}
    return($am);
}

#-----------------------------------------------------------
#  日本語混在の文字列の長さを取得(UTF-8)(文字列)
#-----------------------------------------------------------
sub Klength{

    my ($text) = @_;

     my $textlen = length($text);
     my $pos = 0;
     my $count = 0;

     while ($pos < $textlen) {
         my $code = ord substr($text, $pos, 1); # 先頭のASCIIコード値を取得
        my $bytelen = _bytesize($code);
         $pos += $bytelen;
         $count++; # 文字数をカウント
    }

     return $count;
}

 # 文字のバイト長を求める
sub _bytesize {
    my ($code) = @_;
     my $size = 1;
     if (0x80 & $code) { # 1バイト文字以外
        $size++;
         $code <<= 1;
         for my $i (2 .. 8) {
             last if (!(0x80 & $code));
             $size++;
             $code <<= 1;
         }
     }
     return $size;
}

#----------------------------------------------------------------------
#  日本語混在の文字列から指定した１文字を取得(UTF-8)(文字列、位置)
#----------------------------------------------------------------------
sub KcharAt{

    my ($src, $offset) = @_;

     my $srclen = length($src);
     my $len = 1;
     my $pos = 0;
     my $count = 1;
     my $dest = '';

     while ($pos < $srclen) {
         my $code = ord substr($src, $pos, 1); # 先頭のASCIIコード値を取得
        my $bytelen = _bytesize($code);
         if (defined($len)){
             if ($count >= $offset && $count < ($offset + $len)) {
                 $dest .= substr($src, $pos, $bytelen);
             }
         }
         $pos += $bytelen;
         $count++; # 文字数をカウント
    }

     return $dest;
}

 # 文字のバイト長を求める
sub _bytesize {
     my $code = shift;
     my $size = 1;
     if (0x80 & $code) { # 1バイト文字以外
        $code <<= 1;
         for my $i (2 .. 8) {
             $size++;
             $code <<= 1;
             last if (!(0x80 & $code));
         }
     }
     return $size;
}

#-------------------------------------------------------
#  グラデーション処理
#-------------------------------------------------------
sub CreatGradation {
    my @NewArr;

    my $OrgStr = $_[0];

    if (!$cf{gradstr}) {
        return $OrgStr;
    }
    $OrgStr =~ s/<BR>/\r/g;
    $OrgStr =~ s/<br>/\r/g;
    $OrgStr =~ s/<br \/>/\r/g;

    my @ArrayStr;
    @ArrayStr = split("\r", $OrgStr);

    my @gscol = split(/\s+/, $cf{GradStartColor});
    my @gmcol = split(/\s+/, $cf{GradMidColor});
    my @gecol = split(/\s+/, $cf{GradEndColor});

    my ($S,@chk,$i,$random,$flg);
    foreach $S (@ArrayStr){
        $i = 0;
        if ($in{randgrad} eq "random") {
            @chk = split(/\s+/, $cf{GradStartColor});
            $random = @chk;
            $i = int(rand($random));
        } elsif($in{gradation} ne '') {
            $i = $in{gradation};
        } else {
            $i = $cf{gradnumber};
            $flg = 1;
        }

        my $BufStr;
        if ($flg) {
        $BufStr = $S;
        $BufStr = GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);
        $S = $BufStr;
        } else {
            if ($S =~ /^$cf{gradstr}([^\r]*)/){
            	$BufStr = $1;
                $BufStr = GradStr2($BufStr, @gscol[$i], @gmcol[$i], @gecol[$i]);
                $S =~ s/^$cf{gradstr}([^\r]*)/$BufStr/g;
            }
        }
        push(@NewArr,$S);
    }
    return join("<br />", @NewArr);
}

#-----------------------------------------------------------
#  HTMLヘッダー
#-----------------------------------------------------------
sub header {
	my $ttl = shift;

	print <<EOM;
Content-type: text/html; charset=utf-8

<!doctype html>
<html lang="ja">
<head>
<meta charset="UTF-8">
<meta http-equiv="content-style-type" content="text/css" />
<meta http-equiv="content-script-type" content="text/javascript" />
<meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no">
<meta http-equiv="content-style-type" content="text/css" />
<link href="./cmn/admin.css" rel="stylesheet" type="text/css" />
<script type="text/javascript" src="./cmn/bbs.js"></script>
<script type="text/javascript" src="./cmn/footerFixed_modified.js"></script>
<title>$ttl</title>
</head>
<body>
<div id="head">
<div id="head-in">
	<div id="head-ttl"><h2><img src="$cf{cmnurl}/star.png" alt="star" class="icon"> $cf{version} 管理画面</h2></div>
</div>
</div>
EOM
}

#-----------------------------------------------------------
#  完了メッセージ
#-----------------------------------------------------------
sub message {
	my $msg = shift;

	&header("完了");
	print <<EOM;
<div id="main">
<div id="main-in">
<hr width="350">
<p class="msg">$msg</p>
<hr width="350">
<div class="ta-c">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
<input type="hidden" name="mente_log" value="1">
<input type="submit" value="記事管理画面に戻る">
</form>
</div>
</div></div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div id="footer">
- <a href="https://www.kent-web.com/" target="_top">PETIT BOARD</a> -<br>
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  エラー画面
#-----------------------------------------------------------
sub err_msg {
	my $err = shift;

	header("ERROR");
	print <<EOM;
<div class="ta-c">
<hr width="350" />
<h3>ERROR!</h3>
<p class="red">$err</p>
<hr width="350" />
</div>
</body>
</html>
EOM
	# フッタ
	footer();
	exit;
}

#-----------------------------------------------------------
#  文字カット for UTF-8
#-----------------------------------------------------------
sub cut_str {
	my ($str,$all) = @_;
	$str =~ s|<br( /)?>||g;
	
	my $i = 0;
	my ($ret,$flg);
	while ($str =~ /([\x00-\x7f]|[\xC0-\xDF][\x80-\xBF]|[\xE0-\xEF][\x80-\xBF]{2}|[\xF0-\xF7][\x80-\xBF]{3})/gx) {
		$i++;
		$ret .= $1;
		if ($i >= $all) {
			$flg++;
			last;
		}
	}
	$ret .= '...' if ($flg);
	
	return $ret;
}
#-----------------------------------------------------------
#  戻りボタン
#-----------------------------------------------------------
sub back_btn {
	my $mode = shift;

	print <<EOM;
<div class="ta-r">
<form action="$cf{admin_cgi}" method="post">
<input type="hidden" name="sid" value="$in{sid}">
@{[ $mode ? qq|<input type="submit" name="$mode" value="&lt; 前画面">| : "" ]}
<input type="submit" value="▲メニュー">
</form>
</div>
EOM
}

