#!/usr/bin/perl

#┌─────────────────────────────────
#│  PETIT BOARD v5.4 (2003/01/10)
#│  Copyright(C) Kent Web 2003
#│ http://www.kent-web.com/
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  PETIT BOARD v9.0 LOCK : check.cgi - 2023/06/09
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────

# モジュール宣言
use strict;
use CGI::Carp qw(fatalsToBrowser);

# 外部ファイル取込み
require './init.cgi';
my %cf = set_init();

print <<EOM;
Content-type: text/html; charset=utf-8

<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=shift_jis">
<title>Check Mode</title>
</head>
<body>
<b>Check Mode: [ $cf{version} ]</b>
<ul>
<li>Perlバージョン : $]
EOM



# データファイル
my %log = (
	"$cf{datadir}/log.cgi"         => '記事ログファイル',
	"$cf{datadir}/count.dat"       => 'カウントファイル',
	"$cf{datadir}/pastno.dat"      => '過去ログデータ番号ファイル',
	"$cf{datadir}/pass.dat"        => '管理パスワードデータファイル',
	"$cf{datadir}/ses.cgi"         => 'ログインセッションファイル',
	);
for ( keys %log ) {
	if (-f $_) {
		print "<li>$log{$_}パス : OK\n";
		if (-r $_ && -w $_) {
			print "<li>$log{$_}パーミッション : OK\n";
		} else {
			print "<li>$log{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$log{$_}パス : NG\n";
	}
}

# ディレクトリ
my %dir = (
	$cf{cmnurl}          => '共用ディレクトリ',
	$cf{datadir}         => 'データディレクトリ',
	"$cf{datadir}/past"  => '過去ログディレクトリ',
	"$cf{datadir}/pwd"   => '管理パスワードディレクトリ',
	"$cf{datadir}/ses"   => '管理パスワードセッションディレクトリ',
	);
for ( keys %dir ) {
	if (-d $_) {
		print "<li>$dir{$_}パス : OK\n";
		#next if ($_ eq $cf{datadir});
		
		if (-r $_ && -w $_ && -x $_) {
			print "<li>$dir{$_}パーミッション : OK\n";
		} else {
			print "<li>$dir{$_}パーミッション : NG\n";
		}
	} else {
		print "<li>$dir{$_}パス : NG\n";
	}
}

# テンプレート
foreach (qw(bbs edit enter error find form grad_sample mesg note past read res res_form)) {
	if (-f "$cf{tmpldir}/$_.html") {
		print "<li>テンプレート( $_.html ) : OK\n";
	} else {
		print "<li>テンプレート( $_.html ) : NG\n";
	}
}

# Image-Magick動作確認
eval { require Image::Magick; };
if ($@) {
	print "<li>Image-Magick動作: NG\n";
} else {
	print "<li>Image-Magick動作: OK\n";
}

print <<EOM;
</ul>
</body>
</html>
EOM

exit;

